/**
 * 通用js方法封装处理
 * Copyright (c) 2019 fs
 */

const baseURL = process.env.VUE_APP_BASE_API

export function getAge(strBirthday) {
	var returnAge,
	strBirthdayArr=strBirthday.split("-"),
	birthYear = strBirthdayArr[0],
	birthMonth = strBirthdayArr[1],
	birthDay = strBirthdayArr[2],  
		d = new Date(),
	nowYear = d.getFullYear(),
	nowMonth = d.getMonth() + 1,
	nowDay = d.getDate();   
	if(nowYear == birthYear){
	returnAge = 0;//同年 则为0周岁
	}
	else{
	var ageDiff = nowYear - birthYear ; //年之差
	if(ageDiff > 0){
		if(nowMonth == birthMonth) {
			var dayDiff = nowDay - birthDay;//日之差
			if(dayDiff < 0) {
				returnAge = ageDiff - 1;
			}else {
				returnAge = ageDiff;
			}
		}else {
			var monthDiff = nowMonth - birthMonth;//月之差
			if(monthDiff < 0) {
				returnAge = ageDiff - 1;
			}
			else {
				returnAge = ageDiff ;
			}
		}
	}else {
		returnAge = -1;//返回-1 表示出生日期输入错误 晚于今天
	}
	} 
	return returnAge;//返回周岁年龄
}


// 日期格式化
export function parseTime(time, pattern) {
	if (arguments.length === 0 || !time) {
		return null
	}
	const format = pattern || '{y}-{m}-{d} {h}:{i}:{s}'
	let date
	if (typeof time === 'object') {
		date = time
	} else {
		if ((typeof time === 'string') && (/^[0-9]+$/.test(time))) {
			time = parseInt(time)
		} else if (typeof time === 'string') {
			time = time.replace(new RegExp(/-/gm), '/');
		}
		if ((typeof time === 'number') && (time.toString().length === 10)) {
			time = time * 1000
		}
		date = new Date(time)
	}
	const formatObj = {
		y: date.getFullYear(),
		m: date.getMonth() + 1,
		d: date.getDate(),
		h: date.getHours(),
		i: date.getMinutes(),
		s: date.getSeconds(),
		a: date.getDay()
	}
	const time_str = format.replace(/{(y|m|d|h|i|s|a)+}/g, (result, key) => {
		let value = formatObj[key]
		// Note: getDay() returns 0 on Sunday
		if (key === 'a') { return ['日', '一', '二', '三', '四', '五', '六'][value] }
		if (result.length > 0 && value < 10) {
			value = '0' + value
		}
		return value || 0
	})
	return time_str
}

// 表单重置
export function resetForm(refName) {
	if (this.$refs[refName]) {
		this.$refs[refName].resetFields();
	}
}

// 添加日期范围
export function addDateRange(params, dateRange) {
	var search = params;
	search.beginTime = "";
	search.endTime = "";
	if (null != dateRange && '' != dateRange) {
		search.beginTime = this.dateRange[0];
		search.endTime = this.dateRange[1];
	}
	return search;
}

// 回显数据字典
export function selectDictLabel(datas, value) {
	var actions = [];
	Object.keys(datas).some((key) => {
		if (datas[key].dictValue == ('' + value)) {
			actions.push(datas[key].dictLabel);
			return true;
		}
	})
	return actions.join('');
}

// 回显数据字典（字符串数组）
export function selectDictLabels(datas, value, separator) {
	var actions = [];
	var currentSeparator = undefined === separator ? "," : separator;
	var temp = value.split(currentSeparator);
	Object.keys(value.split(currentSeparator)).some((val) => {
		Object.keys(datas).some((key) => {
			if (datas[key].dictValue == ('' + temp[val])) {
				actions.push(datas[key].dictLabel + currentSeparator);
			}
		})
	})
	return actions.join('').substring(0, actions.join('').length - 1);
}

// 通用下载方法
export function download(fileName) {
	window.location.href = baseURL + "/common/download?fileName=" + encodeURI(fileName) + "&delete=" + true;
}

// 字符串格式化(%s )
export function sprintf(str) {
	var args = arguments, flag = true, i = 1;
	str = str.replace(/%s/g, function () {
		var arg = args[i++];
		if (typeof arg === 'undefined') {
			flag = false;
			return '';
		}
		return arg;
	});
	return flag ? str : '';
}

// 转换字符串，undefined,null等转化为""
export function praseStrEmpty(str) {
	if (!str || str == "undefined" || str == "null") {
		return "";
	}
	return str;
}

/**
 * 构造树型结构数据
 * @param {*} data 数据源
 * @param {*} id id字段 默认 'id'
 * @param {*} parentId 父节点字段 默认 'parentId'
 * @param {*} children 孩子节点字段 默认 'children'
 * @param {*} rootId 根Id 默认 0
 */
export function handleTree(data, id, parentId, children, rootId) {
	id = id || 'id'
	parentId = parentId || 'parentId'
	children = children || 'children'
	rootId = rootId || Math.min.apply(Math, data.map(item => { return item[parentId] })) || 0
	//对源数据深度克隆
	const cloneData = JSON.parse(JSON.stringify(data))
	//循环所有项
	const treeData = cloneData.filter(father => {
		let branchArr = cloneData.filter(child => {
			//返回每一项的子级数组
			return father[id] === child[parentId]
		});
		branchArr.length > 0 ? father.children = branchArr : '';
		//返回第一层
		return father[parentId] === rootId;
	});
	return treeData != '' ? treeData : data;
}

export function dateFormat(fmt, date) {
	let ret="";
	date=new Date(date);
	const opt = {
	  'Y+': date.getFullYear().toString(), // 年
	  'm+': (date.getMonth() + 1).toString(), // 月
	  'd+': date.getDate().toString(), // 日
	  'H+': date.getHours().toString(), // 时
	  'M+': date.getMinutes().toString(), // 分
	  'S+': date.getSeconds().toString() // 秒
	  // 有其他格式化字符需求可以继续添加，必须转化成字符串
	}
	for (let k in opt) {
	  ret = new RegExp('(' + k + ')').exec(fmt)
	  if (ret) {
		fmt = fmt.replace(
		  ret[1],
		  ret[1].length == 1 ? opt[k] : opt[k].padStart(ret[1].length, '0')
		)
	  }
	}
	return fmt
  }

export function formatMoney(s,dot) {     
	s = parseFloat((s + "").replace(/[^\d\.-]/g, "")).toFixed(2) + "";   
	var l = s.split(".")[0].split("").reverse(),   
	r = s.split(".")[1];   
	var t = "";   
	for(var i = 0; i < l.length; i ++ )   {   
	   t += l[i] + ((i + 1) % 3 == 0 && (i + 1) != l.length ? dot : "");   
	}   
	return t.split("").reverse().join("") + "." + r;   
 } 
 export function parseArr(str) {
	if(str==null||str==undefined||str==""){
		return []
	}
	else{
		var strs=str.split(",");
		var data=[];
		strs.forEach(element => {
			data.push(process.env.VUE_APP_BASE_API+element)
		});
		return data;
	}
	 
}


export function parsePost(posts) {
	var postNames="";

	if (posts!=null&&posts.length>0 ) {
		posts.forEach(item => {
			postNames+=item.postName+",";
		})
		
		return postNames.substring(0,postNames.length-1)
	}
	return postNames;
}

export function formatDate(datetime) {
	var date = new Date(datetime);//时间戳为10位需*1000，时间戳为13位的话不需乘1000
	var year = date.getFullYear(),
		month = ("0" + (date.getMonth() + 1)).slice(-2),
		sdate = ("0" + date.getDate()).slice(-2),
		hour = ("0" + date.getHours()).slice(-2),
		minute = ("0" + date.getMinutes()).slice(-2),
		second = ("0" + date.getSeconds()).slice(-2);
	// 拼接
	var result = year + "-"+ month +"-"+ sdate +" "+ hour +":"+ minute +":" + second;
	// 返回
	return result;
}

export function parsePhoto(str) {
	if(str==null||str==undefined||str==""){
		return []
	}
	else{
		var strs=str.split(",");
		var data=[];
		strs.forEach(element => {
			data.push(element)
		});
		return data;
	}
	 
}



 